%% clear everything and load video

% just make sure the script is located in the same 
% folder as video file I use here and run it

clear
clc
close all




%% process frames
tic
videofiledir = dir('\\BIO.AAU.DK\*.mp4'); %Enter video address and name
nfiles = length(videofiledir);
toc
for ii=1:nfiles
    tic
currentfilename=videofiledir(ii).name;
clear ParPos;
k=1;
margin = 20;   % to get rid of the top part
angle = 5;    % rotate image 
minsize = 2;  % min area of particles to detect and ignore smaller ones
toc
figure

obj = VideoReader(videofiledir(ii).name);



tic

ii=1;
%for ff=1:10
while hasFrame(obj)==true % max first 100 frames change to any numbers
  frame = readFrame(obj);
  [h, w, ~] = size(frame);
   subplot 411
   imshow(frame); title('Original frame')

  % rotate and crop
  img = frame;
  img = imrotate(img, angle/180 * pi);
  img = img(margin:h, 5:end-5, :);
  
  % convert to gray and binarize
  img = img(:, :, 3);
  img = ~imbinarize(img, 'adaptive','Sensitivity',0.85);
  img = imdilate(img, strel('disk', 1));
  img = imopen(img, strel('disk', 1));
  
  % analyse particles
  p = regionprops(img, {'Centroid', 'Area'});
  ind = [p.Area] > minsize;
  cent = reshape([p.Centroid], 2, length(ind));
  cent = cent(:, ind);
  
%   %show results
   subplot 211
   imshow(frame); title('Original image')
   subplot 212
   imagesc(img); 
   %title(sprintf('Detected %d particles (%d big enough)', n, sum(ind)));
   hold on
   plot(cent(1, :), cent(2, :), 'rx')
   hold off
   drawnow
  
  % show coordinates of found particles
  %TraceParticles(k;'\nFrame %d\n';cent);
  fprintf('\nFrame %d\n', k);
  fprintf('x = %6.1f, y = %6.1f\n', cent(1, :), cent(2, :))
  
  % 1 sec pause between frames
  %pause(1)
  
  
  
  
  
  % Kber11 added code attempts
  ParPos(k).name=obj.name;
  ParPos(k).xy=cent;
  k=k+1;
  
  
  
  
  
end
puller=obj.name;
puller=erase(puller,'.mp4');
save(puller,'ParPos');

toc
end



